QwtPlotGLCanvas(3)

NAME
QwtPlotGLCanvas - An alternative canvas for a QwtPlot derived from QGLWidget.

SYNOPSIS

#include <qwt_plot_glcanvas.h>

Inherits QGLWidget, and QwtPlotAbstractGLCanvas.

  Public Slots
void replot ()

  Public Member Functions
QwtPlotGLCanvas (QwtPlot *=NULL)
Constructor.
QwtPlotGLCanvas (const QGLFormat &, QwtPlot *=NULL)
Constructor.
virtual ~QwtPlotGLCanvas ()
Destructor.
virtual Q_INVOKABLE void invalidateBackingStore () override
Invalidate the internal backing store.
Q_INVOKABLE QPainterPath borderPath (const QRect &) const
virtual bool event (QEvent *) override

  Protected Member Functions
virtual void paintEvent (QPaintEvent *) override
virtual void initializeGL () override
No operation - reserved for some potential use in the future.
virtual void paintGL () override
Paint the plot.
virtual void resizeGL (int width, int height) override
No operation - reserved for some potential use in the future.

  Additional Inherited Members

Detailed Description

An alternative canvas for a QwtPlot derived from QGLWidget. QwtPlotGLCanvas implements the very basics to act as canvas inside of a QwtPlot widget. It might be extended to a full featured alternative to QwtPlotCanvas in a future version of Qwt.

Even if QwtPlotGLCanvas is not derived from QFrame it imitates its API. When using style sheets it supports the box model - beside backgrounds with rounded borders.

Since Qt 5.4 QOpenGLWidget is available, that is used by QwtPlotOpenGLCanvas.

See also
    QwtPlot::setCanvas(), QwtPlotCanvas, QwtPlotOpenGLCanvas

Note
    With Qt4 you might want to use the QPaintEngine::OpenGL paint engine ( see QGL::setPreferredPaintEngine() ). On a Linux test system QPaintEngine::OpenGL2 shows very basic problems like translated geometries.

    Another way for getting hardware accelerated graphics is using an OpenGL offscreen buffer ( QwtPlotCanvas::OpenGLBuffer ) with QwtPlotCanvas. Performance is worse, than rendering straight to a QGLWidget, but is usually better integrated into a desktop application.

Definition at line 45 of file qwt_plot_glcanvas.h.

Constructor & Destructor Documentation

  QwtPlotGLCanvas::QwtPlotGLCanvas (QwtPlot * plot = NULL) [explicit]

Constructor.

Parameters
    plot Parent plot widget

See also
    QwtPlot::setCanvas()

Definition at line 56 of file qwt_plot_glcanvas.cpp.

  QwtPlotGLCanvas::QwtPlotGLCanvas (const QGLFormat & format, QwtPlot * plot = NULL) [explicit]

Constructor.

Parameters
    format OpenGL rendering options
    plot Parent plot widget

See also
    QwtPlot::setCanvas()

Definition at line 69 of file qwt_plot_glcanvas.cpp.

Member Function Documentation

  QPainterPath QwtPlotGLCanvas::borderPath (const QRect & rect) const
Calculate the painter path for a styled or rounded border

When the canvas has no styled background or rounded borders the painter path is empty.

Parameters
    rect Bounding rectangle of the canvas

Returns
    Painter path, that can be used for clipping

Definition at line 157 of file qwt_plot_glcanvas.cpp.

  bool QwtPlotGLCanvas::event (QEvent * event) [override], [virtual]
Qt event handler for QEvent::PolishRequest and QEvent::StyleChange

Parameters
    event Qt Event

Returns
    See QGLWidget::event()

Definition at line 110 of file qwt_plot_glcanvas.cpp.

  void QwtPlotGLCanvas::paintEvent (QPaintEvent * event) [override], [protected], [virtual]
Paint event

Parameters
    event Paint event

See also
    QwtPlot::drawCanvas()

Definition at line 100 of file qwt_plot_glcanvas.cpp.

  void QwtPlotGLCanvas::replot () [slot]
Invalidate the paint cache and repaint the canvas

See also
    invalidatePaintCache()

Definition at line 131 of file qwt_plot_glcanvas.cpp.

Author

Generated automatically by Doxygen for Qwt User's Guide from the source code.